Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Radiance.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Radiance.pm	(revision 34921)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Radiance.pm	(revision 34921)
@@ -0,0 +1,149 @@
+#------------------------------------------------------------------------------
+# File:         Radiance.pm
+#
+# Description:  Read Radiance RGBE HDR meta information
+#
+# Revisions:    2011/12/10 - P. Harvey Created
+#
+# References:   1) http://www.graphics.cornell.edu/online/formats/rgbe/
+#               2) http://radsite.lbl.gov/radiance/refer/filefmts.pdf
+#------------------------------------------------------------------------------
+
+package Image::ExifTool::Radiance;
+
+use strict;
+use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
+
+$VERSION = '1.02';
+
+# Radiance tags
+%Image::ExifTool::Radiance::Main = (
+    GROUPS => { 2 => 'Image' },
+    NOTES => q{
+        Information extracted from Radiance RGBE HDR images.  Tag ID's are all
+        uppercase as stored in the file, but converted to lowercase by when
+        extracting to avoid conflicts with internal ExifTool variables.  See
+        L<http://radsite.lbl.gov/radiance/refer/filefmts.pdf> and
+        L<http://www.graphics.cornell.edu/online/formats/rgbe/> for the
+        specification.
+    },
+    _orient   => {
+        Name => 'Orientation',
+        PrintConv => {
+            '-Y +X' => 'Horizontal (normal)',
+            '-Y -X' => 'Mirror horizontal',
+            '+Y -X' => 'Rotate 180',
+            '+Y +X' => 'Mirror vertical',
+            '+X -Y' => 'Mirror horizontal and rotate 270 CW',
+            '+X +Y' => 'Rotate 90 CW',
+            '-X +Y' => 'Mirror horizontal and rotate 90 CW',
+            '-X -Y' => 'Rotate 270 CW',
+        },
+    },
+    _command  => 'Command',
+    _comment  => 'Comment',
+    software  => 'Software',
+    view      => 'View',
+   'format'   => 'Format', # <-- this is the one that caused the conflict when uppercase
+    exposure  => {
+        Name => 'Exposure',
+        Notes => 'divide pixel values by this to get watts/steradian/meter^2',
+    },
+    gamma     => 'Gamma',
+    colorcorr => 'ColorCorrection',
+    pixaspect => 'PixelAspectRatio',
+    primaries => 'ColorPrimaries',
+);
+
+#------------------------------------------------------------------------------
+# Extract information from a Radiance HDR file
+# Inputs: 0) ExifTool object reference, 1) DirInfo reference
+# Returns: 1 on success, 0 if this wasn't a valid RGBE image
+sub ProcessHDR($$)
+{
+    my ($et, $dirInfo) = @_;
+    my $raf = $$dirInfo{RAF};
+    my $buff;
+    local $/ = "\x0a";  # set newline character for reading
+
+    # verify this is a valid RIFF file
+    return 0 unless $raf->ReadLine($buff) and $buff =~ /^#\?(RADIANCE|RGBE)\x0a/s;
+    $et->SetFileType();
+    my $tagTablePtr = GetTagTable('Image::ExifTool::Radiance::Main');
+
+    while ($raf->ReadLine($buff)) {
+        chomp $buff;
+        last unless length($buff) > 0 and length($buff) < 4096;
+        if ($buff =~ s/^#\s*//) {
+            $et->HandleTag($tagTablePtr, '_comment', $buff) if length $buff;
+            next;
+        }
+        unless ($buff =~ /^(.*)?\s*=\s*(.*)/) {
+            $et->HandleTag($tagTablePtr, '_command', $buff) if length $buff;
+            next;
+        }
+        # use lower-case tag names to avoid conflicts with reserved tag table entries
+        my ($tag, $val) = (lc $1, $2);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
+        unless ($tagInfo) {
+            my $name = $tag;
+            $name =~ tr/-_a-zA-Z0-9//dc;
+            next unless length($name) > 1;
+            $name = ucfirst $name;
+            $tagInfo = { Name => $name };
+            AddTagToTable($tagTablePtr, $tag, $tagInfo);
+        }
+        $et->FoundTag($tagInfo, $val);
+    }
+    # get image dimensions
+    if ($raf->ReadLine($buff) and $buff =~ /([-+][XY])\s*(\d+)\s*([-+][XY])\s*(\d+)/) {
+        $et->HandleTag($tagTablePtr, '_orient', "$1 $3");
+        $et->FoundTag('ImageHeight', $2);
+        $et->FoundTag('ImageWidth', $4);
+    }
+    return 1;
+}
+
+1;  # end
+
+__END__
+
+=head1 NAME
+
+Image::ExifTool::Radiance - Read Radiance RGBE HDR meta information
+
+=head1 SYNOPSIS
+
+This module is used by Image::ExifTool
+
+=head1 DESCRIPTION
+
+This module contains definitions required by Image::ExifTool to extract meta
+information from Radiance RGBE images.  RGBE (Red Green Blue Exponent)
+images are a type of high dynamic-range image.
+
+=head1 AUTHOR
+
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
+
+This library is free software; you can redistribute it and/or modify it
+under the same terms as Perl itself.
+
+=head1 REFERENCES
+
+=over 4
+
+=item L<http://radsite.lbl.gov/radiance/refer/filefmts.pdf>
+
+=item L<http://www.graphics.cornell.edu/online/formats/rgbe/>
+
+=back
+
+=head1 SEE ALSO
+
+L<Image::ExifTool::TagNames/Radiance Tags>,
+L<Image::ExifTool(3pm)|Image::ExifTool>
+
+=cut
+
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Rawzor.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Rawzor.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Rawzor.pm	(revision 34921)
@@ -15,5 +15,5 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.01';
+$VERSION = '1.05';
 
 # currently support this version Rawzor images
@@ -52,5 +52,5 @@
 sub ProcessRWZ($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my ($buff, $buf2);
@@ -72,21 +72,21 @@
     my $origSize = Get64u(\$buff, 18);
     my $tagTablePtr = GetTagTable('Image::ExifTool::Rawzor::Main');
-    $exifTool->HandleTag($tagTablePtr, RawzorRequiredVersion => $reqVers);
-    $exifTool->HandleTag($tagTablePtr, RawzorCreatorVersion => $creatorVers);
-    $exifTool->HandleTag($tagTablePtr, OriginalFileSize => $origSize);
-    $exifTool->HandleTag($tagTablePtr, CompressionFactor => $origSize/$rwzSize) if $rwzSize;
+    $et->HandleTag($tagTablePtr, RawzorRequiredVersion => $reqVers);
+    $et->HandleTag($tagTablePtr, RawzorCreatorVersion => $creatorVers);
+    $et->HandleTag($tagTablePtr, OriginalFileSize => $origSize);
+    $et->HandleTag($tagTablePtr, CompressionFactor => $origSize/$rwzSize) if $rwzSize;
     # check version numbers
     if ($reqVers > $implementedRawzorVersion) {
-        $exifTool->Warn("Version $reqVers Rawzor images not yet supported");
+        $et->Warn("Version $reqVers Rawzor images not yet supported");
         return 1;
     }
     my $metaOffset = Get64u(\$buff, 38);
     if ($metaOffset > 0x7fffffff) {
-        $exifTool->Warn('Bad metadata offset');
+        $et->Warn('Bad metadata offset');
         return 1;
     }
     # check for the ability to uncompress the information
-    unless (eval 'require IO::Uncompress::Bunzip2') {
-        $exifTool->Warn('Install IO::Compress::Bzip2 to decode Rawzor bzip2 compression');
+    unless (eval { require IO::Uncompress::Bunzip2 }) {
+        $et->Warn('Install IO::Compress::Bzip2 to decode Rawzor bzip2 compression');
         return 1;
     }
@@ -100,9 +100,10 @@
     # 40 int32u - compressed metadata size
     unless ($raf->Seek($metaOffset, 0) and $raf->Read($buff, 44) == 44) {
-        $exifTool->Warn('Error reading metadata header');
+        $et->Warn('Error reading metadata header');
         return 1;
     }
     my $metaSize = Get32u(\$buff, 36);
     if ($metaSize) {
+        $$et{DontValidateImageData} = 1;
         # validate the metadata header and read the compressed metadata
         my $end0 = Get64u(\$buff, 0);
@@ -115,5 +116,5 @@
             $end0 <= $pos1 and $pos1 <= $end1 and $end1 <= $pos2)
         {
-            $exifTool->Warn('Error reading image metadata');
+            $et->Warn('Error reading image metadata');
             return 1;
         }
@@ -122,5 +123,5 @@
             length($buf2) eq $metaSize)
         {
-            $exifTool->Warn('Error uncompressing image metadata');
+            $et->Warn('Error uncompressing image metadata');
             return 1;
         }
@@ -133,17 +134,16 @@
 
         # extract original information by calling ExtractInfo recursively
-        $exifTool->ExtractInfo(\$buff, { ReEntry => 1 });
+        $et->ExtractInfo(\$buff, { ReEntry => 1 });
         undef $buff;
     }
     # set OriginalFileType from FileType of original file
     # then change FileType and MIMEType to indicate a Rawzor image
-    my $origFileType = $exifTool->{VALUE}->{FileType};
+    my $origFileType = $$et{VALUE}{FileType};
     if ($origFileType) {
-        $exifTool->HandleTag($tagTablePtr, OriginalFileType => $origFileType);
-        $exifTool->{VALUE}->{FileType} = 'RWZ';
-        $exifTool->{VALUE}->{MIMEType} = 'image/x-rawzor';
+        $et->HandleTag($tagTablePtr, OriginalFileType => $origFileType);
+        $et->OverrideFileType('RWZ');
     } else {
-        $exifTool->HandleTag($tagTablePtr, OriginalFileType => 'Unknown');
-        $exifTool->SetFileType();
+        $et->HandleTag($tagTablePtr, OriginalFileType => 'Unknown');
+        $et->SetFileType();
     }
     return 1;
@@ -169,5 +169,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Real.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Real.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Real.pm	(revision 34921)
@@ -17,5 +17,5 @@
 use Image::ExifTool::Canon;
 
-$VERSION = '1.04';
+$VERSION = '1.06';
 
 sub ProcessRealMeta($$$);
@@ -356,11 +356,11 @@
 sub ProcessRealProperties($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirLen = $$dirInfo{DirLen};
     my $pos = $$dirInfo{DirStart};
-    my $verbose = $exifTool->Options('Verbose');
-
-    $verbose and $exifTool->VerboseDir('RealProperties', undef, $dirLen);
+    my $verbose = $et->Options('Verbose');
+
+    $verbose and $et->VerboseDir('RealProperties', undef, $dirLen);
 
     while ($pos + 6 <= $dirLen) {
@@ -391,5 +391,5 @@
         my $val = ReadValue($dataPt, $pos, $format, $count, $dirLen-$pos);
 
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
         unless ($tagInfo) {
             my $tagName;
@@ -397,8 +397,8 @@
             next unless $tagName =~ /^\w+$/;    # ignore crazy names
             $tagInfo = { Name => ucfirst($tagName) };
-            Image::ExifTool::AddTagToTable($tagTablePtr, $tag, $tagInfo);
+            AddTagToTable($tagTablePtr, $tag, $tagInfo);
         }
         if ($verbose) {
-            $exifTool->VerboseInfo($tag, $tagInfo,
+            $et->VerboseInfo($tag, $tagInfo,
                 Table  => $tagTablePtr,
                 Value  => $val,
@@ -411,5 +411,5 @@
             );
         }
-        $exifTool->FoundTag($tagInfo, $val);
+        $et->FoundTag($tagInfo, $val);
         $pos += $valLen;
     }
@@ -423,14 +423,14 @@
 sub ProcessRealMeta($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dataPos = $$dirInfo{DataPos};
     my $pos = $$dirInfo{DirStart};
     my $dirEnd = $pos + $$dirInfo{DirLen};
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
     my $prefix = $$dirInfo{Prefix} || '';
     $prefix and $prefix .= '/';
 
-    $verbose and $exifTool->VerboseDir('RealMetadata', undef, $$dirInfo{DirLen});
+    $verbose and $et->VerboseDir('RealMetadata', undef, $$dirInfo{DirLen});
 
     for (;;) {
@@ -455,10 +455,10 @@
 
         my $format = $metadataFormat{$type};
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
         unless ($tagInfo) {
             my $tagName = $tag;
             $tagName =~ tr/A-Za-z0-9//dc;
             $tagInfo = { Name => ucfirst($tagName) };
-            Image::ExifTool::AddTagToTable($tagTablePtr, $tag, $tagInfo);
+            AddTagToTable($tagTablePtr, $tag, $tagInfo);
         }
         if ($verbose) {
@@ -481,5 +481,5 @@
             my $count = int($valueLen / Image::ExifTool::FormatSize($format));
             my $val = ReadValue($dataPt, $valuePos, $format, $count, $dirEnd-$valuePos);
-            $exifTool->HandleTag($tagTablePtr, $tag, $val,
+            $et->HandleTag($tagTablePtr, $tag, $val,
                 DataPt => $dataPt,
                 DataPos => $dataPos,
@@ -499,10 +499,10 @@
                 Prefix => $tag,
             );
-            $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+            $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
         }
         $pos += $size;  # step to next Metadata structure
     }
     unless ($pos == $dirEnd) {
-        $exifTool->Warn('Format error in Real Metadata');
+        $et->Warn('Format error in Real Metadata');
         return 0;
     }
@@ -516,5 +516,5 @@
 sub ProcessReal($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my ($buff, $tag, $vers, $extra, @mimeTypes, %dirCount);
@@ -523,4 +523,5 @@
     $buff =~ m{^(\.RMF|\.ra\xfd|pnm://|rtsp://|http://)} or return 0;
 
+    my $fast3 = $$et{OPTIONS}{FastScan} && $$et{OPTIONS}{FastScan} == 3;
     my ($type, $tagTablePtr);
     if ($1 eq '.RMF') {
@@ -532,5 +533,5 @@
     } else {
         $tagTablePtr = GetTagTable('Image::ExifTool::Real::Metafile');
-        my $ext = $exifTool->{FILE_EXT};
+        my $ext = $$et{FILE_EXT};
         $type = ($ext and $ext eq 'RPM') ? 'RPM' : 'RAM';
         require Image::ExifTool::PostScript;
@@ -544,17 +545,19 @@
                 # must be a Real file type if protocol is http
                 return 0 if $buff =~ /^http/ and $buff !~ /\.(ra|rm|rv|rmvb|smil)$/i;
-                $exifTool->SetFileType($type);
+                $et->SetFileType($type);
+                return 1 if $fast3;
                 undef $type;
             }
             # save URL or Text from RAM file
             my $tag = $buff =~ m{^[a-z]{3,4}://} ? 'url' : 'txt';
-            $exifTool->HandleTag($tagTablePtr, $tag, $buff);
+            $et->HandleTag($tagTablePtr, $tag, $buff);
         }
         return 1;
     }
 
-    $exifTool->SetFileType($type);
+    $et->SetFileType($type);
+    return 1 if $fast3;
     SetByteOrder('MM');
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
 #
 # Process RealAudio file
@@ -565,10 +568,10 @@
         my $fpos = $raf->Tell();
         unless ($raf->Read($buff, 512)) {
-            $exifTool->Warn('Error reading audio header');
+            $et->Warn('Error reading audio header');
             return 1;
         }
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
         if ($verbose > 2) {
-            $exifTool->VerboseInfo($tag, $tagInfo, DataPt => \$buff, DataPos => $fpos);
+            $et->VerboseInfo($tag, $tagInfo, DataPt => \$buff, DataPos => $fpos);
         }
         if ($tagInfo) {
@@ -580,7 +583,7 @@
                 DirStart => 0,
             );
-            $exifTool->ProcessDirectory(\%dirInfo, $subTablePtr);
+            $et->ProcessDirectory(\%dirInfo, $subTablePtr);
         } else {
-            $exifTool->Warn('Unsupported RealAudio version');
+            $et->Warn('Unsupported RealAudio version');
         }
         return 1;
@@ -592,5 +595,5 @@
     my $size = unpack('x4N', $buff);
     unless ($raf->Seek($size - 8, 1)) {
-        $exifTool->Warn('Error seeking in file');
+        $et->Warn('Error seeking in file');
         return 0;
     }
@@ -602,21 +605,21 @@
         last if $tag eq "\0\0\0\0";
         if ($verbose) {
-            $exifTool->VPrint(0, "$tag chunk ($size bytes):\n");
+            $et->VPrint(0, "$tag chunk ($size bytes):\n");
         } else {
             last if $tag eq 'DATA'; # stop normal parsing at DATA tag
         }
         if ($size & 0x80000000) {
-            $exifTool->Warn('Bad chunk header');
+            $et->Warn('Bad chunk header');
             last;
         }
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
         if ($tagInfo and $$tagInfo{SubDirectory}) {
             my $fpos = $raf->Tell();
             unless ($raf->Read($buff, $size-10) == $size-10) {
-                $exifTool->Warn("Error reading $tag chunk");
+                $et->Warn("Error reading $tag chunk");
                 last;
             }
             if ($verbose > 2) {
-                $exifTool->VerboseInfo($tag, $tagInfo, DataPt => \$buff, DataPos => $fpos);
+                $et->VerboseInfo($tag, $tagInfo, DataPt => \$buff, DataPos => $fpos);
             }
             my $subTablePtr = GetTagTable($tagInfo->{SubDirectory}->{TagTable});
@@ -628,14 +631,14 @@
             );
             if ($dirCount{$tag}) {
-                $exifTool->{SET_GROUP1} = '+' . ++$dirCount{$tag};
+                $$et{SET_GROUP1} = '+' . ++$dirCount{$tag};
             } else {
                 $dirCount{$tag} = 1;
             }
-            $exifTool->ProcessDirectory(\%dirInfo, $subTablePtr);
-            delete $exifTool->{SET_GROUP1};
+            $et->ProcessDirectory(\%dirInfo, $subTablePtr);
+            delete $$et{SET_GROUP1};
             # keep track of stream MIME types
-            my $mime = $exifTool->{RealStreamMime};
+            my $mime = $$et{RealStreamMime};
             if ($mime) {
-                delete $exifTool->{RealStreamMime};
+                delete $$et{RealStreamMime};
                 $mime =~ s/\0.*//s;
                 push @mimeTypes, $mime unless $mime =~ /^logical-/;
@@ -643,5 +646,5 @@
         } else {
             unless ($raf->Seek($size-10, 1)) {
-                $exifTool->Warn('Error seeking in file');
+                $et->Warn('Error seeking in file');
                 last;
             }
@@ -650,6 +653,6 @@
     # override MIMEType with stream MIME type if we only have one stream
     if (@mimeTypes == 1 and length $mimeTypes[0]) {
-        $exifTool->{VALUE}->{MIMEType} = $mimeTypes[0];
-        $exifTool->VPrint(0, "  MIMEType = $mimeTypes[0]\n");
+        $$et{VALUE}{MIMEType} = $mimeTypes[0];
+        $et->VPrint(0, "  MIMEType = $mimeTypes[0]\n");
     }
 #
@@ -669,10 +672,10 @@
             );
             my $tagTablePtr = GetTagTable('Image::ExifTool::Real::Metadata');
-            $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+            $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
         } else {
-            $exifTool->Warn('Bad metadata footer');
+            $et->Warn('Bad metadata footer');
         }
         if ($raf->Seek(-128, 2) and $raf->Read($buff, 128) == 128 and $buff =~ /^TAG/) {
-            $exifTool->VPrint(0, "ID3v1:\n");
+            $et->VPrint(0, "ID3v1:\n");
             my %dirInfo = (
                 DataPt => \$buff,
@@ -681,5 +684,5 @@
             );
             my $tagTablePtr = GetTagTable('Image::ExifTool::ID3::v1');
-            $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+            $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
         }
     }
@@ -713,5 +716,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Reconyx.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Reconyx.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Reconyx.pm	(revision 34921)
@@ -7,4 +7,6 @@
 #
 # References:   1) RCNX_MN10.pdf (courtesy of Reconyx Inc.)
+#               2) ultrafire_makernote.pdf (courtesy of Reconyx Inc.)
+#               3) Reconyx private communication
 #------------------------------------------------------------------------------
 
@@ -14,5 +16,15 @@
 use vars qw($VERSION);
 
-$VERSION = '1.02';
+$VERSION = '1.06';
+
+# info for Type2 version tags
+my %versionInfo = (
+    Format => 'undef[7]',
+    ValueConv => 'sprintf("V%.2x.%.2x %.4x:%.2x:%.2x Rev.%s", unpack("CCvCCa", $val))',
+    ValueConvInv => q{
+        my @v = $val =~ /^V([0-9a-f]+)\.([0-9a-f]+) (\d{4}):(\d{2}):(\d{2})\s*Rev\.(\w)/i or return undef;
+        pack('CCvCCa', map(hex, @v[0..4]), $v[5]);
+    },
+);
 
 # maker notes for Reconyx Hyperfire cameras (ref PH)
@@ -81,7 +93,12 @@
         Format => 'int16u[6]',
         Groups => { 2 => 'Time' },
+        Priority => 0, # (not as reliable as EXIF)
         Shift => 'Time',
         ValueConv => q{
             my @a = split ' ', $val;
+            # have seen these values written big-endian when everything else is little-endian
+            if ($a[0] & 0xff00 and not $a[0] & 0xff) {
+                $_ = ($_ >> 8) | (($_ & 0xff) << 8) foreach @a;
+            }
             sprintf('%.4d:%.2d:%.2d %.2d:%.2d:%.2d', @a[5,3,4,2,1,0]);
         },
@@ -92,5 +109,5 @@
         },
         PrintConv => '$self->ConvertDateTime($val)',
-        PrintConvInv => '$val',
+        PrintConvInv => '$self->InverseDateTime($val)',
     },
     0x12 => {
@@ -110,11 +127,13 @@
     0x13 => {
         Name => 'AmbientTemperatureFahrenheit',
+        Format => 'int16s',
         PrintConv => '"$val F"',
-        PrintConvInv => '$val=~/(\d+)/ ? $1 : $val',
+        PrintConvInv => '$val=~/(-?\d+)/ ? $1 : $val',
     },
     0x14 => {
         Name => 'AmbientTemperature',
+        Format => 'int16s',
         PrintConv => '"$val C"',
-        PrintConvInv => '$val=~/(\d+)/ ? $1 : $val',
+        PrintConvInv => '$val=~/(-?\d+)/ ? $1 : $val',
     },
     0x15 => {
@@ -134,8 +153,5 @@
     0x28 => {
         Name => 'InfraredIlluminator',
-        PrintConv => {
-            0 => 'Off',
-            1 => 'On',
-        },
+        PrintConv => { 0 => 'Off', 1 => 'On' },
     },
     0x29 => 'MotionSensitivity', #1
@@ -153,4 +169,249 @@
 );
 
+# maker notes for Reconyx UltraFire cameras (ref PH)
+%Image::ExifTool::Reconyx::Type2 = (
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    TAG_PREFIX => 'Reconyx',
+    WRITABLE => 1,
+    FIRST_ENTRY => 0,
+    NOTES => 'Tags extracted from models such as the UltraFire.',
+  # 0x0a - int32u makernote ID 0x00020000 #2
+  # 0x0e - int16u makernote size #2
+  # 0x12 - int32u public structure ID 0x07f100001 #2
+  # 0x16 - int16u public structure size #2 (0x5d = start of public ID to end of UserLabel)
+    0x18 => { Name => 'FirmwareVersion',   %versionInfo },
+    0x1f => { Name => 'Micro1Version',     %versionInfo }, #2
+    0x26 => { Name => 'BootLoaderVersion', %versionInfo }, #2
+    0x2d => { Name => 'Micro2Version',     %versionInfo }, #2
+    0x34 => {
+        Name => 'TriggerMode',
+        Format => 'undef[1]',
+        PrintConv => {
+            M => 'Motion Detection',
+            T => 'Time Lapse',
+            P => 'Point and Shoot', #2
+        },
+    },
+    0x35 => {
+        Name => 'Sequence',
+        Format => 'int8u[2]',
+        PrintConv => '$val =~ s/ / of /; $val',
+        PrintConvInv => 'join(" ", $val=~/\d+/g)',
+    },
+    0x37 => { #2
+        Name => 'EventNumber',
+        Format => 'int32u',
+    },
+    0x3b => {
+        Name => 'DateTimeOriginal',
+        Description => 'Date/Time Original',
+        Format => 'int8u[7]',
+        Groups => { 2 => 'Time' },
+        Priority => 0, # (not as reliable as EXIF)
+        Shift => 'Time',
+        ValueConv => q{
+            my @a = split ' ', $val;
+            $a[5] += pop(@a) * 256;
+            sprintf('%.4d:%.2d:%.2d %.2d:%.2d:%.2d', reverse @a);
+        },
+        ValueConvInv => q{
+            my @a = ($val =~ /\d+/g);
+            return undef unless @a >= 6;
+            unshift @a, ($a[0] >> 8);
+            $a[1] -= $a[0] * 256;
+            join ' ', @a[6,5,4,3,2,1,0];
+        },
+        PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val)',
+    },
+    0x42 => { #2
+        Name => 'DayOfWeek',
+        Groups => { 2 => 'Time' },
+        PrintConv => {
+            0 => 'Sunday',
+            1 => 'Monday',
+            2 => 'Tuesday',
+            3 => 'Wednesday',
+            4 => 'Thursday',
+            5 => 'Friday',
+            6 => 'Saturday',
+        },
+    },
+    0x43 => {
+        Name => 'MoonPhase',
+        Groups => { 2 => 'Time' },
+        PrintConv => {
+            0 => 'New',
+            1 => 'New Crescent',
+            2 => 'First Quarter',
+            3 => 'Waxing Gibbous',
+            4 => 'Full',
+            5 => 'Waning Gibbous',
+            6 => 'Last Quarter',
+            7 => 'Old Crescent',
+        },
+    },
+    0x44 => {
+        Name => 'AmbientTemperatureFahrenheit',
+        Format => 'int16s',
+        PrintConv => '"$val F"',
+        PrintConvInv => '$val=~/(-?\d+)/ ? $1 : $val',
+    },
+    0x46 => {
+        Name => 'AmbientTemperature',
+        Format => 'int16s',
+        PrintConv => '"$val C"',
+        PrintConvInv => '$val=~/(-?\d+)/ ? $1 : $val',
+    },
+    0x48 => {
+        Name => 'Illumination',
+        PrintConv => { 0 => 'Off', 1 => 'On' },
+    },
+    0x49 => {
+        Name => 'BatteryVoltage',
+        Format => 'int16u',
+        ValueConv => '$val / 1000',
+        ValueConvInv => '$val * 1000',
+        PrintConv => '"$val V"',
+        PrintConvInv => '$val=~s/ ?V$//; $val',
+    },
+    0x4b => {
+        Name => 'SerialNumber',
+        Format => 'string[15]',
+    },
+    0x5a => {
+        Name => 'UserLabel',
+        Format => 'string[21]',
+    },
+);
+
+# maker notes for Reconyx HF2 PRO cameras (ref 3)
+%Image::ExifTool::Reconyx::Type3 = (
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    TAG_PREFIX => 'Reconyx',
+    WRITABLE => 1,
+    FIRST_ENTRY => 0,
+    NOTES => 'Tags extracted from models such as the HF2 PRO.',
+  # 0x0a => { Name => 'StructureVersion',   Format => 'int16u' },
+  # 0x0c => { Name => 'ParentFileSize',     Format => 'int32u' },
+    0x10 => { Name => 'FileNumber',         Format => 'int16u' },
+    0x12 => { Name => 'DirectoryNumber',    Format => 'int16u' },
+  # 0x14 => { Name => 'DirCreateDate',      Format => 'int16u' },
+  # 0x16 => { Name => 'DirCreateTime',      Format => 'int16u' },
+  # 0x18 - int16[8] SDCardLabel
+  # 0x28 => { Name => 'MakerNoteVersion',   Format => 'int16u' },
+    0x2a => {
+        Name => 'FirmwareVersion',
+        Format => 'int16u[3]',
+        ValueConv => 'my @a = split " ",$val; sprintf("%d.%d%c",@a)',
+        ValueConvInv => '$val=~/(\d+)\.(\d+)([a-zA-Z])/ ? "$1 $2 ".ord($3) : undef',
+    },
+    0x30 => {
+        Name => 'FirmwareDate',
+        Format => 'int16u[2]',
+        ValueConv => 'my ($y,$d) = split " ", $val; sprintf("%.4x:%.2x:%.2x",$y,$d>>8,$d&0xff)',
+        ValueConvInv => 'my @a=split ":", $val; hex($a[0])." ".hex($a[1].$a[2])',
+    },
+    0x34 => {
+        Name => 'TriggerMode', #PH (NC) (called EventType in the Reconyx code)
+        Format => 'string[2]',
+        PrintConv => {
+            M => 'Motion Detection', # (seen this one only)
+            T => 'Time Lapse', # (NC)
+            P => 'Point and Shoot', # (NC)
+        },
+    },
+    0x36 => {
+        Name => 'Sequence',
+        Format => 'int16u[2]',
+        PrintConv => '$val =~ s/ / of /; $val',
+        PrintConvInv => 'join(" ", $val=~/\d+/g)',
+    },
+    0x3a => {
+        Name => 'EventNumber',
+        Format => 'int16u[2]',
+        ValueConv => 'my @a=split " ",$val;($a[0]<<16)+$a[1]',
+        ValueConvInv => '($val >> 16) . " " . ($val & 0xffff)',
+    },
+    0x3e => {
+        Name => 'DateTimeOriginal',
+        Description => 'Date/Time Original',
+        Format => 'int16u[6]',
+        Groups => { 2 => 'Time' },
+        Priority => 0, # (not as reliable as EXIF)
+        Shift => 'Time',
+        ValueConv => q{
+            my @a = split ' ', $val;
+            sprintf('%.4d:%.2d:%.2d %.2d:%.2d:%.2d', reverse @a);
+        },
+        ValueConvInv => q{
+            my @a = ($val =~ /\d+/g);
+            return undef unless @a >= 6;
+            join ' ', @a[6,5,4,3,2,1,0];
+        },
+        PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val)',
+    },
+    0x4a => { #2
+        Name => 'DayOfWeek',
+        Groups => { 2 => 'Time' },
+        Format => 'int16u',
+        PrintConv => {
+            0 => 'Sunday',
+            1 => 'Monday',
+            2 => 'Tuesday',
+            3 => 'Wednesday',
+            4 => 'Thursday',
+            5 => 'Friday',
+            6 => 'Saturday',
+        },
+    },
+    0x4c => {
+        Name => 'MoonPhase',
+        Groups => { 2 => 'Time' },
+        Format => 'int16u',
+        PrintConv => {
+            0 => 'New',
+            1 => 'New Crescent',
+            2 => 'First Quarter',
+            3 => 'Waxing Gibbous',
+            4 => 'Full',
+            5 => 'Waning Gibbous',
+            6 => 'Last Quarter',
+            7 => 'Old Crescent',
+        },
+    },
+    0x4e => {
+        Name => 'AmbientTemperatureFahrenheit',
+        Format => 'int16s',
+        PrintConv => '"$val F"',
+        PrintConvInv => '$val=~/(-?\d+)/ ? $1 : $val',
+    },
+    0x50 => {
+        Name => 'AmbientTemperature',
+        Format => 'int16s',
+        PrintConv => '"$val C"',
+        PrintConvInv => '$val=~/(-?\d+)/ ? $1 : $val',
+    },
+    0x52 => { Name => 'Contrast',           Format => 'int16u' },
+    0x54 => { Name => 'Brightness',         Format => 'int16u' },
+    0x56 => { Name => 'Sharpness',          Format => 'int16u' },
+    0x58 => { Name => 'Saturation',         Format => 'int16u' },
+    0x5a => { Name => 'Flash',              Format => 'int16u', PrintConv => { 0 => 'Off', 1 => 'On' } },
+    0x5c => { Name => 'AmbientInfrared',    Format => 'int16u' },
+    0x5e => { Name => 'AmbientLight',       Format => 'int16u' },
+    0x60 => { Name => 'MotionSensitivity',  Format => 'int16u' },
+    0x62 => { Name => 'BatteryVoltage',     Format => 'int16u' },
+    0x64 => { Name => 'BatteryVoltageAvg',  Format => 'int16u' },
+    0x66 => { Name => 'BatteryType',        Format => 'int16u' },
+    0x68 => { Name => 'UserLabel',          Format => 'string[22]' },
+    0x7e => { Name => 'SerialNumber',       Format => 'unicode[15]' },
+);
 
 __END__
@@ -167,9 +428,9 @@
 
 This module contains definitions required by Image::ExifTool to interpret
-maker notes in Reconyx cameras.
+maker notes in images from Reconyx cameras.
 
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
